﻿using System;

class Game
{
    private int players;
    private int[] scores;
    private string[] names;
    private DateTime time;

    public void SetPlayersName()
    {
        for (int i = 0; i < names.Length; i++)
        {
            Console.WriteLine("Please, enter the name of player " + (i + 1));
            names[i] = Console.ReadLine();
        }
    }

    public void SetScore()
    {
        for (int i = 0; i < scores.Length; i++)
        {
            Console.WriteLine("Please, enter the score of " + names[i] +" (player " + (i + 1) + ")");
            scores[i] = int.Parse(Console.ReadLine());
        }
    }

    public void SetScore(int[] scoresP)
    {
        //scores = scoresP;  // You should NOT copy arrays using assignement.
        // Instead, copy the values "by hand":
        
          for (int i = 0; i < scoresP.Length; i++)
        {
            scores[i] = scoresP[i];
        }
    }

    public void SetTime(int year, int month, int day, int hour, int min, int sec)
    {
        time = new DateTime(year, month, day, hour, min, sec);
    }

    public Game(int playersP)
    {
        players = playersP;
        scores = new int[players];
        names = new string[players];
        time = DateTime.Now;
        SetPlayersName();
    }

    public void AddAPlayer()
    {
        players++;
        Array.Resize(ref scores, players);
        Array.Resize(ref names, players);
        Console.WriteLine("Please, enter the name of the new player.");
        names[players - 1] = Console.ReadLine();
    }

    public override string ToString()
    {
        string retS = "--------------------------\n" + time + "\n";
        for(int i = 0; i < players; i++)
        {
            retS += (i + 1) + "\t";
            retS += names[i] + "\t";
            retS += scores[i] + "\n";
        }
        retS += "--------------------------\n";
        return retS;
    }


    /* New code below, what is above is unchanged.*/

    public void SetPlayersName(string[] namesP)
    {
        for (int i = 0; i < names.Length; i++)
        {
            names[i] = namesP[i];
        }
    }

    public Game(int playersP, string[] namesP, int[] scoresP)
    {
        players = playersP;
        scores = new int[players];
        names = new string[players];
        time = DateTime.Now;
        SetPlayersName(namesP);
        SetScore(scoresP);
    }

    public string GreaterScore()
    {
        int greater = scores[0];
        int corresponding = 0;
        for (int i = 1; i < scores.Length; i++)
            if (greater < scores[i])
            {
                greater = scores[i];
                corresponding = i;
            }
        return names[corresponding];
    }

    public string LowerScore()
    {
        int lower = scores[0];
        int corresponding = 0;
        for (int i = 1; i < scores.Length; i++)
            if (lower > scores[i])
            {
                lower = scores[i];
                corresponding = i;
            }
        return names[corresponding];
    }

    public void AddPlayers(int additionalPlayers)
    {
        for (int i = 1; i <= additionalPlayers; i++)
            AddAPlayer();
    }
}

