﻿using System;

class Program
{
    static void Main(string[] args)
    {

        /* 
         * *********
         * Problem 1
         * *********
         * 
         * We want to write a program that compute the product of the integers between an integer j and an integer n.
         * We are assuming that j ≤ n, and that j ≠ 0, n ≠ 0. 
         * Stated mathematically, we want to compute:
         * ∏_{k=j}^{n} k = j × (j + 1) × (j + 2) × ... × (n-1) × n
         * 
         */

        int j = 3, n = 6; // We "hard-code" the values of j and n, but could prompt the user to enter them and validate them before moving forward.
        int product = 1; // Note that the value of this accumulator should'nt be 0! Can you see why?

        for (int k = j; k <= n; k++) // For every value between k and j…
        {
            product *= k; // …multiply product by it!
        }
        Console.WriteLine(product);


        /* 
         * *********
         * Problem 2
         * *********
         * 
         * In Bowling, there are ten frames, and players play their frame taking turns.
         * We want to write a program alternatively telling the k players that it is their turn, for the 10 turns that lasts the game.
         * You can start with only 2 players, and then make it more complex from here.
         * 
         * 
         */

        // Simple version, for 2 players:
        for (int k = 0; k <= 20; k++)
            if (k % 2 == 0) Console.WriteLine("It is my turn");
            else Console.WriteLine("It is your turn.");

        // More complex version, for k players:
        int players = 4; // We "hard-code" k to be 4 in this case.
        for (int t = 0; t < 10; t++)
        {
            for (int p = 1; p <= players; p++)
                Console.WriteLine($"Player {p}'s turn");
        }


        /* 
         * *********
         * Problem 3
         * *********
         * 
         * We want to write a program that generates a random word of length between 6 and 8.
         * The first character should be an upper-case letter, and the remaining characters should be lower-case letters.
         * 
         */

        Random myRandom = new Random();
        int length = myRandom.Next(6, 9); // Generate a random number between 6 and 8, for the length of the word.
        string word = ""; // Declare an empty word.
        char nextChar; // Variable used to store the next character.

        for (int i = 0; i <= length; i++)
        {
            // We want to generate an upper case character for the first letter, i.e., a character whose corresponding integer value will be between 65 and 90. 
            // Lower case characters correspond to values between 97 and 121.
            // Cf. https://en.wikipedia.org/wiki/ASCII#Printable_characters and http://spots.augusta.edu/caubert/teaching/2018/spring/csci1301/lab/14/#part-ii---char-and-int-conversion-ordering-of-characters
            if (i == 0) // For the first character.
            {
                nextChar = (char)(myRandom.Next(65, 91));
            }
            else // For the other characters.
            {
                nextChar = (char)(myRandom.Next(97, 123));

            }
            word += nextChar; // We append the character that was just created to the string we are constructing.
        }
        Console.WriteLine(word);
    }
}

