﻿/*
 * Clément Aubert
 * 03/27/2018
 * Newspaper dispenser -- Project #4
 * This is a possible solution, many other answers were valid.
 * 
 * However, the following were considered as mistakes:
 * - No name and date in delimited comment
 * - Using double instead of decimal
 * - Printing the change even if there isn't any
 * - Impossible to exit the program
 * - Not using string format
 * 
 */

using System;

class Program
{
    static void Main()
    {
        const decimal NewsPaperPrice = 0.60M; // Since the price of the newspaper is not supposed to change, we can store it in a named constant.
        decimal paid = 0; // Even with simple computation like that, double can introduce mistakes: better use decimal!
        string answer = "";

        while (paid < NewsPaperPrice && answer != "e") // Since both variables have been initialized, this comparison makes sense.
        {
            Console.WriteLine("Please insert a coin, using \"n\" for Nickel, " +
                "\"d\" for Dime, and \"q\" for Quarter, or exit using \"e\".");
            // We do not specify that "N", "D", "Q" and "E" are valid answer, but will consider them in the following. 
            answer = Console.ReadLine();
            switch (answer)
            {
                case ("d"):
                case ("D"): // We can have two cases at once!
                    paid += 0.1M;
                    Console.Write($"Your total so far is {paid:C}.\n");
                    break;
                case ("N"):
                case ("n"):
                    paid += .05M;
                    Console.Write($"Your total so far is {paid:C}.\n");
                    break;
                case ("Q"):
                case ("q"):
                    paid += 0.25M;
                    Console.Write($"Your total so far is {paid:C}.\n");
                    break;
                case ("E"):
                case ("e"):
                    answer = "e"; // We "normalize" the entry, it will always be the lower-case version: this will make the tests easier.
                    break;
                default:
                    Console.WriteLine("Sorry, that's an invalid answer.\n");
                    break;
            }
        }
        // We reach this point in the program only if the user paid $0.60 or more, or if "e" or "E" was entered.
        if (answer == "e")
        { // If the user exited…
            Console.WriteLine($"Here are your {paid:C} back.");
        }
        else
        { // Reaching this point means that the user paid $0.60 or more.
            Console.WriteLine("Here is your newspaper.");
            if (paid > NewsPaperPrice) { // We display the following message on the screen only if there is some change due.
                Console.WriteLine($"Here is your change: {(paid - NewsPaperPrice):C}.");
            }
        }
    }
}

