﻿class Shoe
{
    private string type; // Supposed to hold "C" for Children, "M" for Male, "W" for Women
    private double size; // Supposed to hold a value between 1 and 16.
    private string color;

    public Shoe (string typeP, double sizeP, string colorP)
    {
        type = typeP;
        size = sizeP;
        color = colorP;
    }
    /*
     *  Write a getter for color.
     */

    public string GetColor() { return color; }

    /*
     * Write a setter for type. Your setter should take a string as a parameter, and sets the type attribute to the argument given if it is "C", "M" or "W", and set it to "ERROR" otherwise.
     */

    public void SetType (string typeP)
    {
        if (typeP == "W" || typeP == "M" || typeP == "C")
        {
            type = typeP;
        }
        else
        {
            type = "ERROR";
        }
    }
    /*
     * Write a constructor for the Shoe class that takes a double as a parameter, and sets the size attribute to the argument given if it is between 1 and 16 (both included), and sets it to −1 otherwise. You don’t have to assign a value to the other attributes in this constructor.
     */

    public Shoe (double sizeP)
    {
        if (sizeP < 1 || sizeP > 16)
        {
            size = -1;
        }
        else
        {
            size = sizeP;
        }
    }

    /*
     * The following method answer that question:
     * 
     * In the Shoe class, we want to add a static method that takes a string and a double as arguments, and returns the size according to the UK standard, considering that the string was the type of the shoe, and that the double was its size. The good news is that you already know how to do the conversion: that’s what you did in the previous question, the value of ret was actually the size according to UK standards! Write a static method that performs this conversion: it should take two arguments and return a value. Feel free to just indicate where the code from the previous question should go, without re-copying it.
     * 
     * Using the nswer to the previous question, which was:
     * 
     *  Let us pause with the implementation of our class for a minute, and think more generally. Suppose you are given an initialized string variable tyP, an initialized double variable siP, and a double variable ret. Write a piece of code that sets the value of ret to ...
     *  • s - 1 if tyP is "C", and siP is between 5 and 13 (both included),
     *  • s + 12 if tyP is "C", and siP is 1 or 1.5,
     *  • s - 1 if tyP is "C", and siP is between 2 or 4 (both included),
     *  • s - 2.5 if tyP is "W", and siP is between 5.5 and 11 (both included),
     *  • s - 1 if tyP is "M", and siP is between 5 and 16 (both included),
     *  • -1 in all the remaining cases.
     */


    public static double UStoUKConverter(string tyP, double siP)
    {
        double ret;

        if (tyP == "C")
        {
            if (siP <= 13 && siP >= 2)
            {
                ret = siP - 1;
            }
            else if (siP == 1 || siP == 1.5)
            {
                ret = siP + 12;
            }
            else
            {
                ret = -1;
            }
        }
        else if (tyP == "W" && (siP >= 5.5 || siP <= 11))
        {
            ret = siP - 2.5;
        }
        else if (tyP == "M" && (siP >= 5 || siP <= 16))
        {
            ret = siP - 1;
        }
        else
        {
            ret= -1;
        }
        return ret;
    }

    /*
     *  Write a ToString method for the Shoe class. The string returned should contain at least the type, size (in US and UK format), and color, of the calling object.
     */

    public override string ToString()
    { 
        return $"Shoes are for {type}, size {size} ({UStoUKConverter(type, size)} in UK), in {color}."; 
    }

}

