---
title:  CSCI 1301 - Lab 01
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
numbersections: true
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 01}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Thu., 4th January}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

**Deadlines**: You need to complete Part 1 before 04/01/2018, 11:30 [pm]{.smallcaps}, and if you intend to complete Part 3 (which is recommended), the sooner is definitely the better (i.e., make at least an attempt before the end of the week).

**Dependencies**: Once the presentation of the syllabus is done, the three parts can be done independently.


# Part 0 - Syllabus

Follow your instructor's directions while he guides you through the syllabus at <http://spots.augusta.edu/caubert/pcp/>.

# Part I - Desire2Learn

1. Log-in to <https://lms.augusta.edu/> (a.k.a. "Desire2Learn", a.k.a "D2L"). You can use any browser you like ([Firefox](https://www.mozilla.org/firefox/) and [Opera](https://www.opera.com/) are available for every plateform), but keep in mind that you may experience difficulties with [unsupported browser](https://documentation.brightspace.com/EN/brightspace/requirements/all/browser_support.htm).
2. Do one of the following:
 a. If you are familiar with the previous layout of D2L, get used to the new one, you can visit <http://www.augusta.edu/its/daylight.php> for a presentation.
 b. If you're not, you can go see a presentation (that uses the old layout...) at <https://www.augusta.edu/orientation/d2l.php>. Try to get used to the layout. Hopefully it won't change!
3. Find the course's page on D2L. It should be at <https://lms.augusta.edu/d2l/home/291910>, under the heading "*2018-SP-CSCI-1301-XLS Principles of Comp Program I*".
4. Look for the Quiz named "Introduction" under "Assessments" → "Quizzes", and complete it.

# Part II - Configuring Your Installation

Follow the "Before You Begin" Chapter of your textbook, i.e., 

0. You don't need to install Visual Studio (VS), since it is already installed. If you want to install it on your own computer (which is recommended), go to [Part III](#part-3-optional---installing-visual-studio-on-your-own-computer) once you're done with this part, and then follow the instructions below on you own computer.
1. Make Windows Explorer show the file extensions. Follow the instructions at <https://support.microsoft.com/en-us/help/865219/how-to-show-or-hide-file-name-extensions-in-windows-explorer>, at <http://kb.winzip.com/kb/entry/26/>, or consult your textbook.
2. Download the examples of the textbook at <http://deitel.com/bookresources/vcsharphtp6/examples.zip> **Get organized now!** Create a folder for this class, and two sub-folders: one for this first lab, and one where you will extract this `zip` archive.
3. Launch VS, and make sure the line numbers are shown: "Tools" → "Options" → "Text Editor" → "All Languages" →  "General" → "Line Numbers" (VS 15.5.2), or "Text Editor" → "Options" → "All languages" → "Line Numbers".
4. Exit VS, using <kbd>ALT</kbd> + <kbd>F4</kbd>


# Part III (Optional) - Installing Visual Studio On Your Own Computer

This part gathers some references for you to install Visual Studio on your own computer, regardless of your operating system.
It is strongly encouraged that you do so, especially if you want to continue in a CS / IT degree, but not mandatory.
The instructions are not really detailed: feel free to look on the Internet, ask your classmates or instructor for details or help.

1. Go to Dr. Schultz's webpage, <http://spots.augusta.edu/tschultz/resources/SWAvailable.html>. Read the content of the page and click on the additional instructions if needed.
2. If you're not running Windows (i.e., if your operating system is Debian, Android, MacOS, Red Hat, etc.), do the following. You can jump to the next step if you're running Windows.
 a. Install a [Virtual Machine](https://en.wikipedia.org/wiki/Virtual_machine). You can either get "VMware Fusion v10 for Mac" (only for MacOS) on Dr. Schultz's webpage, or download [Virtual Box](https://www.virtualbox.org/) (any operating system).
 b. Download a version of "Microsoft Operating Systems" from Dr. Schultz's webpage.
 c. Install and run your version of Windows from your virtual machine, and go to the next step.
 
3. Look at the difference between the professional and enterprise editions of Visual Studio at <https://www.visualstudio.com/vs/compare/?rr=>.
4. Download "Visual Studio 2017 (v15.5) Enterprise Web installer (exe)" (or the "Professional" edition) from Dr. Schultz's webpage.
5. Get the key for your software, by clicking on `Get VS 2017 Key` and entering your credentials for your Augusta account.
6. Install the software, leaving all the options on their default setting, but check the box next to "Workload" → "Windows" → ".NET-Desktop Development".

There are plently of ways this can go wrong, but make sure you read and followed those instructions carefully before asking for help.

<!--
Pour augmenter la taille de la partition de Windows sous Virtual Box: 
VBoxManage modifyhd /home/caubert/VirtualBox\ VMs/Windows/Windows.vdi --resize 54816
-->
