---
title:  CSCI 1301 - Lab 07
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 07}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Th., 24th January}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

**Deadlines**: This lab needs to be completed and perfectly understood before exam #1 (02/15).

**Dependencies**: This lab uses the knowledge you acquired in all the previous lab.

# Part I - Milestone #1

You accomplished a lot since you started this class.
Let's take a moment to look back at what you learned, and to make sure you understand all those notions and skills.
If you have a doubt, feel free to look back at the corresponding lab.
If you haven't already, look at the "Pushing Further" parts of those previous lab, as noted below.

## What You Learned

### To Use Visual Studio

- What is the structure of a project ([Lab 2 - Part I](../02/#part-i---structure-of-a-project))
- How to open a pre-existing project ([Lab 2 - Part III](../02/#part-iii---compiling-and-executing-your-first-program))
- How to open a template and edit it ([Lab 3 - Part I](../03/#part-i---your-first-own-project))
- How to re-name a project or its files ([Lab 2 - Part V](../02/#part-v---renaming-projects-solutions-and-files))
- To avoid modifying the files of a project outside of VS ([Lab 2 - Part V](../02/#part-v---renaming-projects-solutions-and-files))
- How to compile and execute your program, using a debugger ([Lab 2 - Part III](../02/#part-iii---compiling-and-executing-your-first-program) and [Lab 6 - Part I](../06/#part-i---first-use-of-the-debugger))
- How to zip and share a project ([Homework #1](../../hw/01.pdf))
- How to use the "Find and Replace" feature of VS ([Lab 4 - Part I](../04/#part-i---more-printing-and-escaping))

### To Be Methodical

- Not to be afraid of the documentation ([Lab 2 - Part II](../02/#part-ii---finding-answer))
- To use the following shortcuts (remember that there is a cheatsheet at <http://visualstudioshortcuts.com/>):
  - <kbd>ALT</kbd> + <kbd>F4</kbd> to close VS (or any Windows program, actually)
  - <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>b</kbd> to build the solution
  - <kbd>Ctrl</kbd> + <kbd>F5</kbd> to start the program without debugging
  - <kbd>F10</kbd> or <kbd>F11</kbd> to start the program with the debugger
  - <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>n</kbd> to create a new project
  - <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>F12</kbd> to "jump" to the line where VS thinks there is an error
  - <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>f</kbd> to open the "Find and Replace" menu
  - <kbd>CTRL</kbd> + <kbd>k</kbd>, then <kbd>CTRL</kbd> + <kbd>d</kbd> to indent your code
- To compile your code frequently ([Lab 4 - Part 0](../04/#part-0---preamble))
- To read the error messages ([Lab 2 - Part IV](../02/#part-iv---breaking-and-fixing))
- To organize your files ([Lab 3 - Part 0](../03/#part-0---getting-organized-bis))

### To Write Programs!

- What are the important parts of a program ([Lab 2 - Part IV](../02/#part-iv---breaking-and-fixing))
- To print messages, using `Write` and `WriteLine` ([Lab 3 - Part I](../03/#part-i---your-first-own-project))
- To print messages that includes escape sequences ([Lab 3 - Part I](../03/#discovering-methods-and-escape-sequences) and [Lab 4 - Part I](../04/#part-i---more-printing-and-escaping)) 
- To declare, assign and print variables ([Lab 4 - Part II](../04/#part-ii---first-variables-manipulation) and [Lab 4 - Part III](../04/#part-iii---variables-assignments)) 
- To read a string from the user ([Lab 5 - Part I](../05/#part-i---read-from-the-user))
- To convert a string into integer ([Lab 5 - Part II](../05/#part-ii---variables-types-from-string-to-integer))
- To manipulate various numeric datatypes ([Lab 6 - Part II](../06/#part-ii---numeric-datatypes))
   - To choose the appropriate numeric datatype
   - To determine the "legality" of an operation involving two different datatypes
   - To use the cast operator to explicitely convert between datatypes
   - To be able to identify the datatype of literals
- To read numeric values from the user ([Lab 6 - Part III](../06/#part-iii---reading-other-numeric-datatypes))

### Academic Life

- Not to be afraid of your professor (hopefully!).
- How, where, and when to ask for help.
- What are my expectations for this class.
- How to organize your workflow, the importance of planning ahead.
- ... to be continued!

Maybe you decided what your major was going to be.
Maybe you changed your mind.
Maybe you're not sure.
Being confused and uncertain is sometimes part of the process of taking decisions and learning, and that's all right.
It is normal to hesitate.
[This page by a colleague in Computer Science](http://spots.gru.edu/mdowell/Right%20major.html) may be a good read for students hesitating between IT, CS and MIS, or wanting to have more information about those majors.


### Did You Pushed Further?

If you haven't done the optional parts of the lab, it may be a good moment to go back and look at them.
**Computer Science and Information Technology (aspiring) majors are strongly recommended to look at those "Pushing Further" parts.**
Those parts help you to be ready for the future: they prepare you for the next lab, give you heads-up on the lecture, and tease your curiosity.
In them, you learned (or you'll learn):

- How to classify programming languages ([Lab 2](../02/#part-optional---pushing-further))
- What is the difference between `.NET Core` and `.NET framework` ([Lab 3](../03/#part-ii-optional---pushing-further))
- How to print unicode characters ([Lab 3](../03/#part-ii-optional---pushing-further))
- How to use composite formatting ([Lab 4](../04/#part-iv-optional---pushing-further))
- How to use namespaces in a different way ([Lab 4](../04/#part-iv-optional---pushing-further) and [Lab 5](../05/#part-iii-optional---pushing-further))
- How to convert an `int`, a `float` and a `double` into a `string` ([Lab 5](../05/#part-iii-optional---pushing-further) and [Lab 6](../06/#part-iv-optional---pushing-further))

a. Open one of your project.
It can be any project, as long as it uses variables. 
b. Make sure you can compile and run it.
c. Hit <kbd>F11</kbd> once.
Observe what happen.
Move the black screen where the printing happen (called the *console*, or *Command prompt*) to see your code.
Hit <kbd>F11</kbd> a couple of times, and see what happen.
You are executing your code line by line, and can track many useful information, including the value and datatype of your variables (in the "Locals" panel / window).
e. You can find out at <https://msdn.microsoft.com/en-us/library/y740d9d3.aspx> (VS 2015) or <https://docs.microsoft.com/en-us/visualstudio/debugger/navigating-through-code-with-the-debugger> (VS 2017) alternative ways of starting the debugging functionalities of VS.


# Part II - Working on Problem-Solving

Here is a problem that involves almost all the previously mentioned notions and skills.
It is phrased in a more abstract way, closer to the kind of problem you will be facing if you were a software-developer.
Think about what you need to do before starting to type your code, and when you start writing your code, make sure you compile it frequently.

> Write a program that asks the user for their name, their number of guests, and the number of pizzas they have.
> Your program should then print the name of the user, the number of people at the party, the number of pizzas, and what portion of pizza will everyone have, assuming the pizzas will be shared equitably.

A couple of additional precisions:

- The user of the program also want some pizza, so the number of people at the party is the number of guests plus one.
- Once you're done, you need to test your program:
    - What happen if the user provide "normal", plausible data? Does your program work as expected?
    - What happen if the name of the user is a numeric value?
    - What happen if the user have 2 guests and 4 pizza? Will everyone get 4 / 3 = 1 + ⅓ pizza, as they normally should?
    - What happen if the user have 0 pizzas?
    - What happen if the user have 0 guests?
    - What happen if the user have -4 pizzas?
    - What happen if the user have -1 guests?

It would be nice if you could use (some of) the following techniques:

- Combined assignment operator
- Unicode printing (make it stylish!)
- Cast operator (the number of guests is an integer, and you could think that bringing non-whole pizzas at a party could be weird, so that the number of pizza would also need to be an integer)
- String concatenation
