---
title:  CSCI 1301 - Lab 10
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 10}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Tue., 6th February}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

**Deadlines**: You don't have to complete this lab before the first exam, but doing so would definitely help you.
You have to complete it before the 20th of February.

# Part I - Writing A Circle Class

This time, you will have to start your project "from scratch" and shouldn't try to edit a previous program.

## Foundations

a. Create a new project in VS, name it "Circle".
b. In the Solution Explorer, right-click on "Circle", then on "Add..." and select "Class".
Then, select "Class", write "Circle.cs" as the name of the file, and click on "Add".
c. You are now suppose to have two `.cs` files opened and displayed in the Solution Explorer: `Program.cs` and `Circle.cs`.
d. Declare one single instance variable in `Circle.cs`, of type `double` and named `radius`.
Write a `set` and a `get` method for this instance variable.
e. In `Program.cs`, write statements that create a new `Circle` object and set its radius to $2.3$.
Print its radius using the method you defined previously.

## Extending the Class

a. In C#, `Math.PI` is a `double` holding an approximation of $π$.
In the `Main` method of `Program.cs`, write a statement that prints its value.
b. In the `Circle.cs` file, add two methods:
  1. A method that returns the circumference of the circle that calls it (i.e., $2 π$ times the radius),
  2. A method that returns the area of the circle that calls it (i.e., $π$ times the radius squared).
c. Test those two methods in your `Main` program, by printing the area and the circumference of the object you created at the previous exercise.

## Custom Constructors

a. Write a constructor that takes a `double` as argument, and set the value of the radius created to the value given as a parameter.
Note that you can't compile your program anymore.
Why?
b. Edit the way you were creating the object in the `Main` method to make your program complilable again. Instead of the default constructor (that isn't available anymore), use the constructor you just defined.
c. Add a custom "no-args" constructor to your class, using
~~~~{.cs}
public Circle() { }
~~~~~
d. Edit your `Main` method so that two objects are created: one using the "no-args" constructor, one using the constructor that takes an argument.

## Post-implementation Design

Draw the UML diagram for the class you just implemented.
Make sure it matches perfectly your implementation.

# Part II (Optional) - Pushing Further

The following are two independent tasks, to widen your understanding of this class, sharpen your coding skills, and prepare you for the next labs.

a. Re-open your `Rectangle` project from the previous lab and write three constructors:
   - One that doesn't take any argument and set both attributes to $1$,
   - One that takes one argument, and set both the length and the width to the value passed as argument,
   - One that takes two arguments and set the length to the first value passed as argument, and the width to the second value passed as argument.

   Test them, and make sure they have the expected behavior.
   
b. Have a look at the `Math` class's specification, at <https://docs.microsoft.com/en-us/dotnet/api/system.math?view=netframework-4.7.1>
Can you write a statement that prints the result of $Min(2^{14}, ⌊log(4000⌋)$? 
