---
title:  CSCI 1301 - Lab 11
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 11}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Thu., 8th February}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

**Deadlines**: I strongly recommend that you complete this lab before the first exam.

# Part I - Writing A Tip Calculator

Your friend learned that you now know how to program, and would like to know if you could develop the following program:

> The idea would be that your program would ask me how much the check is, how many we are, and what percentage we want to leave as a tip.
> Your program would then print how much we need to pay (assuming we split equitably).
>
> What would be great is if you could round things up (I often pay cash, so I don't want to have to carry small change with me): so for instance, if we are two and the check is \$23, plus 15% tip, \$23 + (\$23 × 0.15) = $26.45, we need to pay \$13.225 each, but I'd rather have us both pay \$14 and leave a small extra tip.
> Oh, and can you make it look nice, and print all the information?
> How much we left as a tip, what percentage it makes, etc.


## Thinking

Think about your friend's demands, and how you could write this program (for now, you can think of it as being entirely in a `Main` method, you don't have to construct a class).
Write on a piece of paper the steps needed.
The general structure should be:

1. Gather the data
2. Compute
3. Print

Try to decompose those three steps further: what messages you need to print to gather the data, how many numbers, or variables, you need to manipulates, what is the exact computation, what you need to print at the last step, etc.
Make sure you understand how to do the computation, without thinking about the tools you actually have in C#.

## Coding

Now is time to think about the actual code you need to write.
You should have all the tools you need to complete the steps you identified at the previous exercise.
The "rounding part" could be problematic, but you have two different tools to solve this question: you can either truncate (using explicit conversion) and then add one, or use the `Math` class, that was [introduced in last lab's "Pushing Further"](../10/#part-ii-optional---pushing-further).


# Part II (Optional) - Pushing Further

Your tip calculator works great and your friend is happy.
You now realize that you could make one step further and actually write a class to perform those tasks.
Think about the specifications of this class (how many attributes, what methods) and include a `ToString` method in it.
