---
title:  CSCI 1301 - Lab 15
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 15}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Thu., 1st March}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

# Part I - Practicing if and switch

Initialize a `day` string variable, a `myVar` int variable and a `initial` char variable.
During this part, change and display on the screen the values of those variables to test that your statements behave as they are supposed to.

## From switch to if-else

a. Write a `switch` statement that sets a flag to true if the value of `day` if `"Mon."`, `"Tue."`, `"Wed."`, `"Thu."` or `"Fri."`, and to false otherwise. 
b. Rewrite the previous statement as an `if-else` statement.

## From if-else to switch

c. Write a `if-else` statement that doubles the value of `myVar` if `myVar` is `3`, `5` or `7`.
d. Can you rewrite the previous statement as a `switch` statement?

## Deciding

e. Write a statement that doubles the value of `myVar` and sets `initial` to 'M' if `day` is equal to `"Sat"`.
What is the appropriate kind of statement to do this?
f. Write a statement that displays "Hello" on the screen if the value of `initial` is `'E'` or `'e'`, "Bonjour" if the value of `initial` is `'F'` or `'f'`, "Guten Tag" if the value of `inital` is `D` or `d`. What is the appropriate kind of statement to do this?

## Complex Conditions

g. Write a statement that doubles the value of `myVar` if `day` is `"Sun."`, triples the value of `myVar` if `day` is not `"Sun."` and `initial` is `'a'`, sets `myVar` to `0` otherwise.
h. Write a statement that sets `myVar` to `t` if `initial` is an upper-case letter, and to `f` otherwise. You can either use the `IsUpper` method (<https://msdn.microsoft.com/en-us/library/9s91f3by(v=vs.110).aspx>), or look at [the part II of the previous lab](../14/#art-ii---char-and-int-conversion-ordering-of-characters) to understand how to test if a character is an upper-case letter.

# Part II - Wireless Service Provider Problem

## Description 

A wireless service provider has three different subscription packages for its customers.

- Package A: For \$$9.95$ per month, $10$ GB of data are provided.
Additional GB are \$$2.00$ per GB.
- Package B: For \$$14.95$ per month, $20$ GB of  data are provided.
Additional GB are \$$1.00$ per GB.
- Package C: For \$$19.95$ per month, unlimited data is provided.

We want to design and implement a class for this wireless service provider.

## Design

Design a class named `WSP` that calculates a customer's monthly bill. 
It should contains:

a. Attributes for both the letter of the package the customer has purchased (A, B, or C) and the amount of data (in GB) that the customer has used.
b. Accessors and mutators for all attributes.
c. A no-arg constructor that defaults to package A and no GB used.
d. A constructor that sets all fields using its parameters. 
e. A method that calculates a customer's total charges for the package they have chosen.
f. A method that calculates and displays the amount of money Package A customers would have saved if they had purchased Package B or Package C, and the amount of money Package B customers would save if they purchased Package C.

Write the UML diagram for this class.

## Implementation

Work on the `WSP` class and on a test program in parallel: implement the steps a., b. and c., and then write a small test program.
Make sure you can compile your program, and that it behaves as expected before continuing.
Write the second constructor, and test it by creating an object using it.
Continue with e., test the method, and finally write f.
To test this last method, you should create numerous objects, and call the method with them.

Try to use a `switch` statement for this last method.

