---
title:  CSCI 1301 - Lab 16
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 16}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Tue., 6th March}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

# Part 0 - Wrapping Up

The code we just studied in class, slightly expanded and with an application program, is [available to download](LoanCalculator.zip).

# Part I - Milestone #2

You accomplished a lot since Milestone #1 (that was presented in [Lab 07](../07)), so let's take a moment to look back at what you learned.

## What You Learned

### To Get Better at Using Softwares

- How to have 2 `.cs` files open in one project in VS ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class))
- How to "undo" things, using <kbd>CTRL</kbd> + <kbd>z</kbd> ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class))
- How to use a software to compare text files ([Lab 12 - Part I](../12/#part-i---comparing-text-files))

### To Design, Edit and Enhance Classes

- How to draw UML diagrams ([Lab 9 - Part II](../09/#part-ii---writing-your-own-class), [Lab 10 - Part I](../10/#part-i---writing-a-circle-class))
- That renaming uniformily attribute names was possible ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class))
- How to modify a pre-existing class ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class))
- How to add methods to your class ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class))
- To write your custom constructor ([Lab 10 - Part I](../10/#part-i---writing-a-circle-class))
- To write or edit a `ToString` method ([Lab 12 - Part III](../12/#part-iii---project-3))
- To write static methods ([Lab 12 - Part III](../12/#part-iii---project-3))
- To write "no-args" constructor ([Lab 10 - Part I](../10/#part-i---writing-a-circle-class))

### To Use Classes

- To create objects, using the default constructor ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class))
- To use setters and getters ([Lab 8 - Part I](../08/#part-i---using-a-pre-defined-class), [ Lab 12 - Part II](../12/#part-ii---a-class-for-chemical-elements))
- To create objects, using custom constructor ([Lab 10 - Part I](../10/#part-i---writing-a-circle-class))
- To use `ToString` methods ([Lab 12 - Part II](../12/#part-ii---a-class-for-chemical-elements))
- To use static methods ([Lab 12 - Part II](../12/#part-ii---a-class-for-chemical-elements))

### Various

- To use constant values ([Lab 10 - Part I](../10/#part-i---writing-a-circle-class))
- To convert `int` into `char`, and reciprocally ([Lab 14 - Part II](../14/#part-ii---char-and-int-conversion-ordering-of-characters))
- To read a single character from the user ([Lab 14 - Part II](../14/#part-ii---char-and-int-conversion-ordering-of-characters))

### To Write Branching Programs

- To understand logical operators ([Lab 13 - Part I](../13/#part-i-truth-tables))
- To understand precedence among operators ([Lab 13 - Part II](../13/#part-ii-precedence-and-order-of-evaluation))
- To write simple `if` statements ([Lab 14 - Part I](../14/#part-i-basic-conditional-statements))
- To practise writing programs that use nested `if` ([Lab 14 - Part III](../14/#part-iii---problem-solving))

### To Solve Problems!

- To decompose a problem into smaller pieces ([Lab 11 - Part I](../11/#part-i---writing-a-tip-calculator))
- To enhance pre-existing code ([Lab 12 - Part III](../12/#part-iii---project-3))
- To write a game! ([Lab 13 - Part III](../13/#part-iii-a-guessing-game))
- To design and implement basic decision-tree ([Lab 14 - Part III](../14/#part-iii---problem-solving))
- To implement and test in parallel a complex class ([Lab 15 - Part II](../15/#part-ii---wireless-service-provider-problem))

## Did You Pushed Further?

- Have a look at properties ([Lab 8 - Part II](../08/#part-ii-optional---pushing-further))
- Have a look at the variety of UML diagrams ([Lab 9 - Part III](09/#part-iii-optional---pushing-further))
- Know more about the `Math` class ([Lab 10 - Part II](../10/#part-ii-optional---pushing-further))
- Rework previous problems ([Lab 8 - Part II](../08/#part-ii-optional---pushing-further), [Lab 10 - Part II](../10/#part-ii-optional---pushing-further), [Lab 11 - Part II](../11/#part-ii-optional---pushing-further))
- Design a static class ([Lab 13 - Part IV](../13/i#part-iv-pushing-further-optionnal))
- Have a first look at `for` statement ([Lab 14 - Part IV](../14/part-iv-pushing-further-optionnal))
- Discover how strings are ordered ([Lab 14 - Part IV](../14/part-iv-pushing-further-optionnal))


# Part II - Working on Problem-Solving

Download, extract, compile and execute [Course.zip](Course.zip).
Then, read the code, and make sure you understand everything in it: the role of the static attribute, the difference between the two constructors, the branching in the constructor that takes two arguments.
Then, do the following:

a. Write a `ToString` method that returns
    1. The name of the student, followed by
    2. "is registered for section A." of the student is in section A, "is on the waiting list." if the student is on the waiting list.
b. Test your method in the program, printing the information about various students.
c. Your next step will be to open a second section:
    1. We want to have a section B, with 4 seats available. Implement the existence of this section with a static attribute.
    2. The constructor that takes one argument should now assign the student to section A if there is room available, to section B if section A is full but section B isn't, or to the waiting list if both sections are full.
    3. Think about how you should change the constructor that takes two arguments, and implement what seems to be logical. For instance, if a student wants to enroll in section B, but section B is full and section A isn't, should the student go to section A or be on the waiting list?
    4. Finally, correct your `ToString` method, so that the string returned describes accurately the section the student is enrolled in.

Bonus: There is an inconsistency in the constructor that takes two arguments, can you spot it?
What will happen if the user gave a code for the section that isn't `'A'` or `'a'`, and section A is full?
Can you fix this?
