---
title:  CSCI 1301 - Lab 17
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 17}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Thu., 13th March}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---


# Part I - User Input Validation

## Integer Validation

Consider the code we just studied:

~~~~~~~~{.cs}
Console.WriteLine("Please enter a positive number");
int n = int.Parse(Console.ReadLine());
while (n < 0)
{
    Console.WriteLine($"You entered {n}, I asked you for a positive number. Please try again.");
    n = int.Parse(Console.ReadLine());
}
~~~~~~~~

#. As always, start by creating a blank project, copy-and-paste that "snippet" into the `Main` method, compile it and execute it.
#. Then, copy and, comment it out, and adapt your copy so that the user will be asked to enter an integer between $0$ and $100$, and asked again as long as (s)he does not comply.
#. Re-do the previous step, but change the condition, so that the user has to enter an even number.

## String Validation

Adapt the code above to perform string validation: ask the user to enter a string, and as long as the user does not enter "Yes" or "No", ask him/her again to enter a value.

# Part II - First While Loops

#. Write a `while` loop that display the "*" character 100 times at the screen.

#. Modify your previous loop, so that a new line character is displayed on the screen every time 10 "*" has been displayed on the screen.
That is, your program should display on the screen:

~~~~~~~~
**********
**********
**********
**********
**********
**********
**********
**********
**********
**********
~~~~~~~~

# Part III - TryParse Method

## Getting Familiar With It

Consider the code we just studied:

~~~~~~~~{.cs}
Console.WriteLine("Please, enter an integer.");
string message = Console.ReadLine();
int a;
bool res = int.TryParse(message, out a);
if (res)
    {
        Console.WriteLine($"The value entered was an integer: {a}.");
    }
else
    {
        Console.WriteLine("The value entered was not an integer, so 0 is assigned to a.");
    }
Console.WriteLine(a);
~~~~~~~~

What happen if:

- The user enters an integer?
- The user enters a floating-point value?
- The user enters nothing?
- The user enters a string that contains alphabetical characters?

## Using It

Write a code that ask the user to enter an integer, and ask the user again as long as the user entered something that isn't an integer.

# Part IV - Pushing Further

The following are two independent tasks, to widen your understanding of this class, and to prepare you for the next labs.

#. Actually, there is a `TryParse` method in other classes as well: there is for instance a `Double.TryParse` and a `Decimal.TryParse` method. Write a small program that uses one of them.

#. Write a `static` method that takes a `string` as an argument, and return a boolean: `true` if the string given as a parameter is an integer, `false` otherwise. You should use `TryParse` in the body of your method. Note that you can define a `static` method in the same file as your `Main` method:

~~~~~~~~{.cs}
class Program
    {

    static bool MyMethod(string param)
    {
        // Code goes here, we just return false to avoid an error message:
        return false;
    }
    static void Main()
    {
        Console.WriteLine(MyMethod("Test"));
    }
}
~~~~~~~~
