---
title:  CSCI 1301 - Lab 21
author: Clément Aubert
dir: ltr
lang: en
documentclass: scrartcl
papersize: letter
header-includes:
 - \setromanfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setmainfont[Ligatures={Common,TeX}]{Linux  Libertine O}
 - \setsansfont{Linux Biolinum O}
 - \setmonofont{DejaVu Sans Mono}
 - \usepackage{xunicode}
 - \hypersetup{colorlinks=true, allcolors=black}
 - \topmargin=-0.45in
 - \evensidemargin=0in
 - \oddsidemargin=0in
 - \textwidth=6.5in
 - \textheight=9.0in
 - \headsep=0.25in
 - \linespread{1.1}
 - \setlength\parindent{0pt}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}\renewcommand{\footrulewidth}{0.4pt}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Lab 21}}
 - \rhead{CSCI 1301 - Principles of Computer Programming I--Spring 2018}
 - \lfoot{Thu., 27nd March}
 - \cfoot{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
 - \usepackage{fvextra}
 - \DefineVerbatimEnvironment{Highlighting}{Verbatim}{breaklines,commandchars=\\\{\}}
---

This lab is a review session: come with questions and problems, that we can try to solve together.
There are two activities below, do them if times allow, or to start a discussion.

# Part I -- Solving Project #4

You can download 

- [A possible solution for the "Newspaper dispenser"](NewsPaperDispenser.zip) problem,
- [A possible solution for the "Rock, Paper, Scissors Game"](RockPaperScissors.zip) problem

(_nota: those files will be back after the Fall 2018 class completed this assignment._)

# Part II -- Pushing Further (Optional)

Some students used two techniques that were not introduced in class to solve the 4th project, here is a short presentation of them.

a. `ToLower`: `String` is actually a class, and not a datatype. It means that it comes with methods, as any class does. Among them is a method called `ToLower`, that doesn't take any argument, and returns a copy of the string calling it converted to lowercase.
A typical example of usage would be:

~~~~~~~{.cs .numberLines .lineAnchors}
string test = "HI MOM";
test = test.ToLower();
Console.WriteLine(test);
~~~~~~~

There are numerous other methods, listed at <https://msdn.microsoft.com/en-us/library/system.string_methods(v=vs.110).aspx>.
Here is an example of a statement using `EndsWith`, a method that takes a string as argument and returns a boolean:

~~~~~~~{.cs .numberLines .lineAnchors}
string test2 = Console.ReadLine();
if (test2.EndsWith("mom")) {
    Console.WriteLine("The string you entered ends with \"mom\"!");
}
~~~~~~~

Write statements using `StartsWith` and `ToUpper`, two methods really similar to the ones we just introduced.

b. `Environment.Exit` is a brutal way of exiting a progam, but it works: 

~~~~~~~{.cs .numberLines .lineAnchors}
using System;
class Test
    {
    public static void Main()
    {
        Environment.Exit(0);
        Console.WriteLine("Hi Mom!");
    }
}
~~~~~~~

This is definitely not the kind of code you should be using at this point: `goto`, `Environment.Exit` and empty `return` were used by some of you to exit the program, but a fine handling of conditional statements was enough to do what was needed. As of now, you should refrain from using such statements, but knowing them could be useful in the future.
